var ModelFinder = Java.type('com.change_vision.jude.api.inf.project.ModelFinder'); 
var IEREntity = Java.type('com.change_vision.jude.api.inf.model.IEREntity');
var IERModel = Java.type('com.change_vision.jude.api.inf.model.IERModel');
var IERDatatype = Java.type('com.change_vision.jude.api.inf.model.IERDatatype');

var ERModelFinder = new ModelFinder() { 
isTarget: function(element) { 
		  return element instanceof IERModel;
	  }
}

var entityFinder = new ModelFinder() { 
isTarget: function(element) { 
		  return element instanceof IEREntity;
	  }
}
var ERDataFinder = new ModelFinder() { 
isTarget: function(element) { 
		  return element instanceof IERDatatype;
	  }
}

var editor = astah.getModelEditorFactory().getERModelEditor();
var erModel = astah.findElements(ERModelFinder);

function getERDatatype(name){
	for each(var type in astah.findElements(ERDataFinder)){
		if(type.getName() == name){
			return type;
		}
	}
	return null;
}

function restoreEREntity(model) {
	if(model == null) {
		return;
	}
	var taggedValues = model.getTaggedValues();
	for each(var taggedValue in taggedValues) {
		var key = taggedValue.getKey();
		var value = taggedValue.getValue();
		if(key == "DatatypeName"){
			var type = getERDatatype(value);
			if(type == null){
				type = editor.createERDatatype(erModel,value);
			}
			model.setDatatype(type);
		}
	}
}

function run() {
	for each(var entity in astah.findElements(entityFinder)) {
		for each(var key in entity.getPrimaryKeys()){
			restoreEREntity(key);
		}
		for each(var key in entity.getNonPrimaryKeys()){
			restoreEREntity(key);
		}
	}
}


run();
